﻿// SurfWatch 1.0 - Created by Steven Nagy
// URL: http://surfwatch.snagy.name  Email: steven@snagy.name


var DaysOfWeek = new Array(7);
DaysOfWeek[0] = ["Sunday", "Sun"];
DaysOfWeek[1] = ["Monday", "Mon"];
DaysOfWeek[2] = ["Tuesday", "Tue"];
DaysOfWeek[3] = ["Wednesday", "Wed"];
DaysOfWeek[4] = ["Thursday", "Thu"];
DaysOfWeek[5] = ["Friday", "Fri"];
DaysOfWeek[6] = ["Saturday", "Sat"];

function FindDayOfWeek(day) {
    var i;
    for (i=0;i<7;i++) {        
        if (DaysOfWeek[i][0].toUpperCase() == day.toString().toUpperCase()) {
            return i;
        }
        if (DaysOfWeek[i][1].toUpperCase() == day.toString().toUpperCase()) {
            return i;
        }
    }
    return -1;
}

function FindDateFromInputDay(day) {
    var theDate = new Date();
    var today = theDate.getDay();
      
    var selectedDay = FindDayOfWeek(day);
    
    var offset = selectedDay - today;
    
    if (offset>3) offset=offset-7;
    if (offset<-3) offset=offset+7;
        
    theDate.setDate(theDate.getDate()+offset);
    
    return theDate;
}

function FindDate(html) {
    var dayAndTime = RemoveTagType(html, "br").toUpperCase();
    var space = dayAndTime.toString().indexOf(" ");
    var remainder = dayAndTime.toString().substring(space+1, dayAndTime.length);
    remainder = remainder.replace(" ", "");
    
    var asDate = FindDateFromInputDay(dayAndTime.toString().substring(0, space));    
    var time = GetTime(remainder);
    
    asDate.setHours(time, 0, 0, 0);
    return asDate;
}

function GetTime(html) {
    
    var am = html.indexOf("AM");
    var pm = html.indexOf("PM");
    
    if (am>=0) {
        var time = html.toString().substring(0, am);        
        return time;
    }
    if (pm>=0) {
        var time = html.toString().substring(0, pm);        
        time = Number(time) + 12;        
        return time;
    }
    return 6;
}

function FindClosestIndexForCurrentTime(array) {
    // row 0 (first row) has dates, starting from second column (index 1)
    var now = new Date();    
    // Find out which 2 dates we are in between, then take the earlier of the 2
    var index;
    for (index=1;index<array[0].length;index++) {        
        if (now<array[0][index]) {
            return index-1;
        }
    }
    // if we don't match, then just return the first record because this is usually 
    // closest to the current date anyway
    return 1;     
}

function FormatDateAsDayAndTime(someDate) {
    
    var output = new String();
    output += DaysOfWeek[someDate.getDay()][1];
    output += ", ";
    output += someDate.getHours() + ":00";
    return output;    
}