﻿// SurfWatch 1.0 - Created by Steven Nagy
// URL: http://surfwatch.snagy.name  Email: steven@snagy.name


function GetTextForIndex(array, index, template) {
    var output = new String();
    
    var lastUpdate = FormatDateAsDayAndTime(array[0][index]);
    
    var gustMax = array[1][index][0];
    var gustAvg = array[1][index][1];
    
    var gustDirection = RemoveTagType(RemoveTagType(array[2][index], "BR"), "IMG");
    
    var waveMax = array[3][index][0];  
    var waveAvg = array[3][index][1];  
    
    var wavePeriod = array[4][index];
    var waveDirection = RemoveTagType(RemoveTagType(array[5][index], "BR"), "IMG");
    
    var beachName = GetBeach();
    
    output = template;
    output = output.replace('%GUSTAVG%', gustAvg);
    output = output.replace('%GUSTMAX%', gustMax);
    output = output.replace('%GUSTDIR%', gustDirection);
    output = output.replace('%WAVEAVG%', waveAvg);
    output = output.replace('%WAVEMAX%', waveMax);
    output = output.replace('%WAVEDIR%', waveDirection);
    output = output.replace('%WAVEPERIOD%', wavePeriod);
    output = output.replace('%TIME%', lastUpdate);
    output = output.replace('%BEACH%', beachName);
        
    return output;
}

function GetWaveHeightForIndex(array, index) {
    var waveAvg = array[3][index][1]; 
    return Number(waveAvg);
}

function GetBeach() {
    if (CurrentBeachID > 0) {
        return PredefinedLocations[CurrentBeachID-1][1]
    }
    else {
        return (CurrentBeachLat + '/' + CurrentBeachLong);
    }
}