﻿// SurfWatch 1.0 - Created by Steven Nagy
// URL: http://surfwatch.snagy.name  Email: steven@snagy.name


var NewIndex = 0;

function ConvertArrayDates(array) {
    // The first index contains all the dates as strings.
    var i;
    for (i=1;i<array[0].length;i++) {        
        array[0][i] = FindDate(array[0][i]);        
    }
    
    return array;
}

function ConvertHtmlTableToArray(html) {
    // Starts with <TABLE and reads until it finds </TABLE
    // if it finds a <TABLE again, it calls itself recursively
    
    var upperHTML = html.toString().toUpperCase();            
    var i = upperHTML.indexOf("<TABLE");  
    
    if (i<0) {        
        return null;
    }
        
    var tag = new String();
    var array = new Array();
    var rowIndex = new Number();
    rowIndex = 0;
    var colIndex = new Number();
    colIndex = 0;
    
    while (i>=0) {
        i = upperHTML.indexOf("<", i+1);                  
        if (i==-1) {
            return array;
        }      
        
        tag = GetTagType(i, upperHTML);
        var tagClose = upperHTML.indexOf(">", i+1) + 1;
        
        switch (tag.toUpperCase()) {
            case "TR":
                array[rowIndex] = new Array();
                colIndex = 0;                
                break;
            case "TD":                                
                array[rowIndex][colIndex] = GetCellContent(upperHTML, tagClose);                
                break;
            case "/TR":                
                colIndex = 0;  
                rowIndex++;
                break;
            case "/TD":                
                colIndex++;
                break;
            case "TABLE":                       
                array[rowIndex][colIndex] = ConvertHtmlTableToArray(upperHTML.substring(i));                
                i = i + NewIndex - 1;                
                break;
            case "/TABLE":                
                NewIndex = tagClose;                       
                return array;
                break;
        }       
        
    }
}

function GetCellContent(html, startIndex) {
    if (html.toString().substring(startIndex).indexOf("<TABLE")==0) {
        return "";
    }
    var closeCell = html.indexOf("</TD", startIndex);
    
    if (closeCell>startIndex) {
        return html.toString().substring(startIndex, closeCell);
    }
    return "";
}

function GetTagType(index, html) {
   
   var space = html.indexOf(" ", index);
   var close =  html.indexOf(">", index);
   
   if (space<0 && close<0) return "";
   if (space<0) return html.toString().substring(index+1, close);
   if (close<0) return html.toString().substring(index+1, space);   
   if (space<close) return html.toString().substring(index+1, space);
   if (close<space) return html.toString().substring(index+1, close);
   return "";
}


function RemoveTagType(html, tagType) {
    var upperHTML = html.toString().toUpperCase();
    var search = "<" + tagType.toString().toUpperCase();
    var i = upperHTML.indexOf(search);
    if (i<0) return upperHTML;
    
    while (i!=-1) {
        var closeTag = html.indexOf(">", i+1);
        
        upperHTML = upperHTML.replace(upperHTML.substring(i, closeTag+1), "");
    
        i = upperHTML.indexOf(search);
    }
    
    return upperHTML;
}


