﻿// SurfWatch 1.0 - Created by Steven Nagy
// URL: http://surfwatch.snagy.name  Email: steven@snagy.name

var textTemplate1 = '<div id="WaveHeight"><span title="Summarises average and maximum wave height (in feet), period (in seconds), and wave direction">Waves:</span> ' + 
                    '<span title="Average wave height in feet">%WAVEAVG%</span> ' +
                    '<span title="Maximum wave height in feet">(%WAVEMAX%)</span> ' + 
                    '<span title="Wave break direction">%WAVEDIR%</span></div>' + 
                    '<div id="WavePeriod"><span title="Period in seconds on average between wave peaks">Period: %WAVEPERIOD% seconds</span></div>';
                   
var textTemplate2 = '<div id="WindSpeed"><span title="Summarises average and maximum wind speed (in knots) and direction">Wind:</span> ' + 
                    '<span title="Average wind speed in knots">%GUSTAVG%</span> ' + 
                    '<span title="Maximum wind speed in knots">(%GUSTMAX%)</span> ' +
                    '<span title="Wind gust direction">%GUSTDIR%</span></div>' + 
                    '<div id="UpdateTime"><span title="Time of last weather update">Last Update: %TIME%</span></div>';

var link = 'surfwatch.snagy.name';
var textTemplate3 = '<div id="BeachSummary">Beach: %BEACH%</div>' +                     
                    '<div id="LogoText">' + 
                    '<div id="AuthorLink"><a href="http://' + link + '/">&#169; SurfWatch</a></div></div>' + 
                    '<div id="SnagyLogo"><img src="Images/Logo/logo-dots-10.gif"></div>';
                    

function Startup() {    
    LoadBeachIDFromAPI();
    var siteURL = GetUrl();
    LoadSiteData(siteURL, ProcessHtml);    
    StartRefreshEngine(ProcessHtml, GetUrl);    
}

function GetUrl() {
    var newURL = siteURL;
    newURL = newURL.replace("%LATITUDE%", CurrentBeachLat);
    newURL = newURL.replace("%LONGITUDE%", CurrentBeachLong);
    newURL = newURL + "&asd=" + Math.random();
    return newURL;
}

var text1;
var text2;
var text3;

var ProcessedArray;
function ProcessHtml(html) {
    continueTextCycle = 0;
    
    var startIndex = html.toString().indexOf(SourceTableStart, 0);
    var endIndex = html.toString().indexOf(SourceTableEnd, SourceTableStart+1);
    var tableHtml = html.toString().substring(startIndex, endIndex + SourceTableEnd.length)
    
    ProcessedArray = ConvertHtmlTableToArray(tableHtml);    
    ProcessedArray = ConvertArrayDates(ProcessedArray);       
    
    var i = FindClosestIndexForCurrentTime(ProcessedArray);
            
    var height = GetWaveHeightForIndex(ProcessedArray, i);
    ChangeBackgroundForHeight(height);
    
    text1 = GetTextForIndex(ProcessedArray, i, textTemplate1);
    text2 = GetTextForIndex(ProcessedArray, i, textTemplate2);    
    text3 = GetTextForIndex(ProcessedArray, i, textTemplate3);        
    
    RestartCycling();
}

function RestartCycling() {
    if (CurrentCycling==1) {
        setTimeout("RestartCycling()", 1000);
    }
    else {
        var BeachListDiv = document.getElementById('BeachListDiv');
        if (lastCycleTimerID!=-1) {
            clearTimeout(lastCycleTimerID);
            lastCycleTimerID = -1;
        }
        StartTextCycle(text1, text2, text3, BeachListDiv);
    }
}

function LoadBeachIDFromAPI() {    
    var newBeachID = System.Gadget.Settings.read("BeachID");    
    if (newBeachID) {
        var i;
        for (i=0;i<PredefinedLocations.length;i++) {        
            if (Number(PredefinedLocations[i][0]) == Number(newBeachID)) {
                CurrentBeachID = Number(newBeachID);
                CurrentBeachLat = PredefinedLocations[i][2];
                CurrentBeachLong = PredefinedLocations[i][3];                            
                break;
            }
        }
    }
}